#!*****************************************************************************
#!*****************************************************************************
#TEMPLATE(TvSRollB,'TvS File RollBack Template'),Family('ABC')
#!*****************************************************************************
#!*****************************************************************************
#HELP('TvSABC.HLP')
#!
#!----------------------------------------------------------------------------------------------
#EXTENSION(TvSRollB,'TvS RollBack Embed Code & Data Extension'),DESCRIPTION('TvS Rollback Extension Template'),HLP('TvSRollB')
#!----------------------------------------------------------------------------------------------
#LOCALDATA
TvS:TRollBFile       STRING(25)
#ENDLOCALDATA
#SHEET
#TAB('TvS Template - File "Logout-Rollback-Commit" update                                        ')
#IMAGE('io2.ICO'),AT(10,20)
#DISPLAY ('Innovative Options cc'),AT(40,20)
#DISPLAY ('Cape Town, South Africa'),AT(40,30)
#DISPLAY ('Tel: +27 21 5526013   Fax: +27 21 5525582')
#DISPLAY ('Email: innopt@iafrica.com')
#DISPLAY (' ')
#DISPLAY('Template is used as follows;')
#DISPLAY('  1. First add the extension to the procedure properties')
#DISPLAY('  2. Select the file(s) you wish to ADD records to and')
#DISPLAY('     those to be UPDATED only (e.g. a Number Control file.')
#DISPLAY('     This must be done for both INSERT and CHANGE')
#DISPLAY('  3. Multiple detail records (e.g. for a CHILD file) must')
#DISPLAY('     FIRST be loaded to a queue (using EMBED code).')
#DISPLAY('  4. On the update button insert "Rollback" code on')
#DISPLAY('     "Control Events, Accepted, Before Generated Code"')
#DISPLAY(' ')
#DISPLAY('  ')
#BOXED('Select files (and queue) to action')
   #DISPLAY(' ')
   #DISPLAY('         On Insert                                 On Change')
   #Button('Files to ADD'),Multi(%NoFilesToAdd,%FileToAdd),AT(10,210)
   #PROMPT('Files To ADD',FILE),%FileToAdd,UNIQUE
   #endbutton
   #Button('Files to ADD'),Multi(%NoCFilesToAdd,%CFileToAdd),AT(100,210)
   #PROMPT('Files To ADD',FILE),%CFileToAdd,UNIQUE
   #endbutton
   #Button('Files to PUT'),Multi(%NoFilesToPut,%FileToPut),AT(10,225)
   #PROMPT('Files To PUT',FILE),%FileToPut,UNIQUE
   #endbutton
   #Button('Files to PUT'),Multi(%NoCFilesToPut,%CFileToPut),AT(100,225)
   #PROMPT('Files To PUT',FILE),%CFileToPut,UNIQUE
   #endbutton
   #Button('File to Add from Queue'),Multi(%NoQueToAdd,%QueToAdd),AT(10,240)
   #PROMPT('File to Add from Queue',FILE),%QueToAdd,UNIQUE
   #endbutton
   #DISPLAY(' ')
   #ENABLE(%QueToAdd <> ' ')
   #DISPLAY('If a file is selected to be filled from a queue a queue')
   #DISPLAY('named "TvSQueue", with the prefix "TQue" will be')
   #DISPLAY('created with the same fields as the selected file.')
   #PROMPT('Prefix of the file the queue',@S5),%QuePre,AT(100,300),PROMPTAT(10,300),REQ
   #DISPLAY(' will update, maximum 5 characters')
   #ENDENABLE
#ENDBOXED
#DISPLAY('This template was developed by Theo von Solms')
#DISPLAY('Comments and/or enhancements would be appreciated')
#ENDTAB
#ENDSHEET
#DISPLAY(' ')
#!----------------------------------------------------------------------------------------------
#AT(%DataSectionAfterWindow)
TvSGroup    LIKE(%QueToAdd.Record)
TvSQueue       QUEUE(TvSGroup),PRE(TQue)
               END
#ENDAT
#!----------------------------------------------------------------------------------------------
#AT(%ProcedureRoutines)
#COMMENT(1)
#<!----------------------------------------------------------------------------------------------
ErrHandler ROUTINE                                       !Error routine
   ROLLBACK
   MESSAGE(' Unable to process transaction for ' & TvS:TRollBFile & '| Entire transaction will be aborted','FILE UPDATE ERROR')
   EXIT
#ENDAT
#!*****************************************************************************
#AT(%ProcedureRoutines)
#COMMENT(1)
#<!----------------------------------------------------------------------------------------------
FileRollBack ROUTINE       ! This routine handles the actual updates to the various files
#DECLARE(%RollList)
#DECLARE(%Logout)
#DECLARE(%FileCount,LONG)
#DECLARE(%CRollList)
#DECLARE(%CLogout)
#DECLARE(%CFileTotal,LONG)
#DECLARE(%CFileCount,LONG)
!  Start of TvS File Rollback Routine
#!
#! Start of Record Insert Routine
#!
#SET(%FileCount,1)
#LOOP
   #SELECT(%NoFilesToAdd,%FileCount)
   #IF(%FileToAdd = ' ')
      #SET(%FileCount,%FileCount - 1)
      #BREAK
   #ELSE
      #SET(%RollList,%RollList & ',' & %FileToAdd)
      #SET(%FileCount,%FileCount + 1)
   #ENDIF
#ENDLOOP
#IF(%FileCount <> 0)
   ! ---- InsertRecord - Files to Add = %FileCount
#ENDIF
#!
#SET(%FileCount,1)
#LOOP
   #SELECT(%NoFilesToPut,%FileCount)
   #IF(%FileToPut = ' ')
      #SET(%FileCount,%FileCount - 1)
      #BREAK
   #ELSE
      #SET(%RollList,%RollList & ',' & %FileToPut)
      #SET(%FileCount,%FileCount + 1)
   #ENDIF
#ENDLOOP
#IF(%FileCount <> 0)
   ! ---- InsertRecord - Files to Put = %FileCount
#ENDIF
#SELECT(%NoQueToAdd,1)
#IF(%QueToAdd <> ' ')
   #SET(%RollList,%RollList & ',' & %QueToAdd)
#ENDIF
#IF(%RollList <> ' ')
   IF ThisWindow.Request = InsertRecord
   #SET(%Logout,'LOGOUT(1' & %RollList &')')
      %Logout
      IF ERRORCODE()
         TvS:TRollBFile = 'Rollback File List'
         DO ErrHandler
         EXIT
      END
      #EMBED(%CustomCodeIns,'Rollback "InsertRecord" - Before File Update'),HLP('TvSRollb')
   #FOR(%NoFilesToAdd)
      IF Access:%FileToAdd.Insert()                                ! Update file with initialised values
         TvS:TRollBFile = '%FileToAdd'                     ! Set error identification reference
         DO ErrHandler
         EXIT
      END                               ! Call error handling routine
   #ENDFOR
   #FOR(%NoFilesToPut)
      IF Access:%FileToPut.Update()
         TvS:TRollBFile = '%FileToPut'                     ! Set error identification reference
         DO ErrHandler
         EXIT
      END                                  ! Call error handling routine
   #ENDFOR
   #FOR(%NoQueToAdd)
      LOOP X# = 1 TO RECORDS(TvSQueue)                  ! Process stored detail records in QUEUE
         GET(TvSQueue,X#)                               ! Get one record from the QUEUE
         IF ERRORCODE()
            TvS:TRollBFile = '%QueToAdd Queue'
            DO ErrHandler
            EXIT
         END
         %QuePre:Record = TvSQueue                          ! Assign QUEUE values to record buffer
         #EMBED(%CustomCodeQue,'Rollback "Update Queue" - Before File Update')
         IF Access:%QueToAdd.Insert()                                     ! Add record to file
            TvS:TRollBFile = '%QueToAdd'
            DO ErrHandler
            EXIT
         END
      END
   #ENDFOR
      COMMIT
   END   !  ThisWindow.Request = Insert
#ENDIF
#! --------- start of record change code ---------------------------
#SET(%CFileCount,1)
#LOOP
   #SELECT(%NoCFilesToAdd,%CFileCount)
   #IF(%CFileToAdd = ' ')
      #SET(%CFileCount,%CFileCount - 1)
      #BREAK
   #ELSE
      #SET(%CRollList,%CRollList & ',' & %CFileToAdd)
      #SET(%CFileCount,%CFileCount + 1)
   #ENDIF
#ENDLOOP
#IF(%CFileCount <> 0)
   ! ---- ChangeRecord - Files to Add = %CFileCount
#ENDIF
#!
#SET(%CFileCount,1)
#LOOP
   #SELECT(%NoCFilesToPut,%CFileCount)
   #IF(%CFileToPut = ' ')
      #SET(%CFileCount,%CFileCount - 1)
      #BREAK
   #ELSE
      #SET(%CRollList,%CRollList & ',' & %CFileToPut)
      #SET(%CFileCount,%CFileCount + 1)
   #ENDIF
#ENDLOOP
#IF(%CFileCount <> 0)
   ! ---- ChangeRecord - Files to Put = %CFileCount
#ENDIF
#IF(%CRollList <> ' ')
   IF ThisWindow.Request = ChangeRecord
      #SET(%CLogout,'LOGOUT(1' & %CRollList &')')
      %CLogout
      IF ERRORCODE()
         TvS:TRollBFile = 'Rollback File List'
         DO ErrHandler
         EXIT
      END
      #EMBED(%CustomCodeCha,'Rollback for "ChangeRecord" - Before File Update'),HLP('TvSRollb')
      #FOR(%NoCFilesToAdd)
      IF Access:%CFileToAdd.Insert()                                ! Update file with initialised values
         TvS:TRollBFile = '%CFileToAdd'                     ! Set error identification reference
         DO ErrHandler
         EXIT
      END                                ! Call error handling routine
      #ENDFOR
      #FOR(%NoCFilesToPut)
      IF Access:%CFileToPut.Update()
         TvS:TRollBFile = '%CFileToPut'                     ! Set error identification reference
         DO ErrHandler
         EXIT
      END                
      #ENDFOR
      COMMIT
   END   !  ThisWindow.Request = Change
#ENDIF
#ENDAT
#!*****************************************************************************
#CODE(Rollback,'File Update Rollback Code')
#DISPLAY('')
#DISPLAY(' This should be embedded in')
#DISPLAY('    Control Event Handling')
#DISPLAY('       Before Generated Code')
#DISPLAY(' ')
#DISPLAY(' ')
#DISPLAY('Template adds the following code;')
#DISPLAY('     DO FileRollBack')
#DISPLAY('     RETURN(Level:Fatal)')
   DO FileRollBack
   RETURN(Level:Fatal)
#!----------------------------------------------------------------------------------------------
#!==============================================================================================